import java.io.*;
import java.net.*;
import java.util.*;

class MainClient  {

    BufferedReader br;
    PrintStream ps;
    Socket sock;
    int idClient;

    public MainClient(String serverAddr, int port) throws IOException {

	sock = new Socket(serverAddr,port);
	br = new BufferedReader(new InputStreamReader(sock.getInputStream()));
	ps = new PrintStream(sock.getOutputStream());
    }

    public void mainLoop() {

	double x = 0;
	double y = 0;
	double z = 0;
	double prec = 0.5;
	boolean ok = false;
	String answer = "";

	try {
	    // recv id
	    answer = br.readLine();
	    idClient = Integer.parseInt(answer);
	    System.out.println("my id is "+idClient);
	    
	    // send 10 requests n°1
	    for(int i=0;i<10;i++) {
		ps.println("1");
		ps.println(idClient);		
		ps.println(x+","+y+","+z);
		answer = br.readLine();
		if (answer.equals("REQ_ERR")) {
		    System.out.println("error with request #1 format");
		}
		else if (answer.equals("NOID_ERR")) {
		    System.out.println("error with request #1 client id (unknown)");
		}	    		
		x += 2;
		y += 3;
		z += 1;
	    }

	    // send request n°2
	    ps.println("2");
	    ps.println(idClient);
	    answer = br.readLine();
	    if (answer.equals("REQ_ERR")) {
		System.out.println("error with request #2 format");
	    }
	    else if (answer.equals("NOID_ERR")) {
		System.out.println("error with request #2 client id (unknown)");
	    }	    
	    else {
		System.out.println("path length = "+answer);
	    }

	    // send requests n°3
	    x = 4.1; y = 5.9; z = 2.05;
	    ps.println("3");
	    ps.println(idClient);
	    ps.println(prec+","+x+","+y+","+z);
	    answer = br.readLine();
	    if (answer.equals("REQ_ERR")) {
		System.out.println("error with request #3 format");
	    }
	    else if (answer.equals("NOID_ERR")) {
		System.out.println("error with request #3 client id (unknown)");
	    }	    	    
	    else {
		System.out.println("found ("+x+","+y+","+z+")? "+answer);
	    }
	    x += 1;
	    ps.println("3");
	    ps.println(idClient);	    
	    ps.println(prec+","+x+","+y+","+z);
	    answer = br.readLine();
	    if (answer.equals("REQ_ERR")) {
		System.out.println("error with request #3 format");
	    }
	    else if (answer.equals("NOID_ERR")) {
		System.out.println("error with request #3 client id (unknown)");
	    }	    	    
	    else {
		System.out.println("found ("+x+","+y+","+z+")? "+answer);
	    }
	}
	catch(IOException e) {
	    System.out.println("cannot communicated with server. Aborting");
	}
    }     
}
		
