import java.io.*;
import java.net.*;
import java.util.*;

class MainClient  {

    BufferedReader br;
    PrintStream ps;
    Socket sock;
    int idClient;
    BufferedReader consoleIn; // to read from keyboard

    public MainClient(String serverAddr, int port) throws IOException {
	
	consoleIn = new BufferedReader(new InputStreamReader(System.in));
	
	sock = new Socket(serverAddr,port);
	br = new BufferedReader(new InputStreamReader(sock.getInputStream()));
	ps = new PrintStream(sock.getOutputStream());
    }

    public void mainLoop() {

	double x = 0;
	double y = 0;
	double z = 0;
	double prec = 0.5;
	boolean ok = false;
	String answer = "";
	String req = "";	
	boolean stop = false;

	try {
	    // recv id
	    answer = br.readLine();
	    idClient = Integer.parseInt(answer);
	    System.out.println("my id is "+idClient);

	    // reading requests from keyboard
	    while (!stop) {
		System.out.print("PositionClient [type request]> ");
		req = consoleIn.readLine();
		if (req == null) {
		    stop = true;
		}
		else {
		    String[] parts = req.split(" "); // separate req. name from params.
		    if (parts[0].equals("storepos")) {
			requestStorePos(parts[1]);
		    }
		    else if (parts[0].equals("pathlen")) {
			requestPathLen();
		    }
		    else if (parts[0].equals("findpos")) {
			requestFindPos(parts[1]);
		    }
		    else if (parts[0].equals("slope")) {
			requestSlope();
		    }
		    else if (parts[0].equals("posothers")) {
			requestPosOthers();
		    }		    
		    else if (parts[0].equals("quit")) {
			stop = true;
		    }
		}
	    }	    
	}
	catch(IOException e) {
	    System.out.println("cannot communicated with server. Aborting");
	}
    }

    protected void requestStorePos(String params) throws IOException {
	String answer="";
	ps.println("1");
	ps.println(idClient);
	ps.println(params);
	answer = br.readLine();
	if (answer.equals("REQ_ERR")) {
	    System.out.println("error with request #1 format");
	}
	else if (answer.equals("NOID_ERR")) {
	    System.out.println("error with request #1 client id (unknown)");
	}							
    }

    protected void requestPathLen() throws IOException {
	String answer="";
	ps.println("2");
	ps.println(idClient);
	answer = br.readLine();
	if (answer.equals("REQ_ERR")) {
	    System.out.println("error with request #2 format");
	}
	else if (answer.equals("NOID_ERR")) {
	    System.out.println("error with request #2 client id (unknown)");
	}			
	else {
	    System.out.println("path length = "+answer);
	}	
    }

    protected void requestFindPos(String params) throws IOException {
	String answer="";
	ps.println("3");
	ps.println(idClient);
	ps.println(params);
	answer = br.readLine();
	if (answer.equals("REQ_ERR")) {
	    System.out.println("error with request #3 format");
	}
	else if (answer.equals("NOID_ERR")) {
	    System.out.println("error with request #3 client id (unknown)");
	}
	else {
	    System.out.println("found position? "+answer);
	}	
    }

    protected void requestSlope() throws IOException {
	String answer="";
	ps.println("4");
	ps.println(idClient);
	answer = br.readLine();
	if (answer.equals("REQ_ERR")) {
	    System.out.println("error with request #4 format");
	}
	else if (answer.equals("NOID_ERR")) {
	    System.out.println("error with request #4 client id (unknown)");
	}			
	else {
	    System.out.println("slope D+ = "+answer);
	    answer = br.readLine();
	    System.out.println("slope D- = "+answer);
	}	
    }
    
    protected void requestPosOthers() throws IOException {
	String answer="";
	ps.println("5");
	ps.println(idClient);
	answer = br.readLine();
	if (answer.equals("REQ_ERR")) {
	    System.out.println("error with request #5 format");
	}
	else if (answer.equals("NOID_ERR")) {
	    System.out.println("error with request #5 client id (unknown)");
	}			
	else {
	    String[] lstPos = answer.split(",");
	    for(int i=0;i<lstPos.length/3;i++) {
		System.out.print("| "+lstPos[3*i]+","+lstPos[3*i+1]+","+lstPos[3*i+2]+" ");
	    }
	    System.out.println();
	}	
    }
    
}
		
